#include<algorithm>
#include<iostream>
#include<cstdio>
#include<vector>

using namespace std;

const int N = 20+1, M = 36+1, S = 720+1, C = 15+1;

int n;
string str;
vector<pair<int, int> > edges;
int a[N][N];

int print(int a){
    if(a < 10)
        cout << "  " << a;
    else
        cout << " " << a;
}

int s;
int esyms[S][M];
int syms[S][N];
int sym[N];
bool used[N];
void find_syms(int level=0){
    if(level == n){
        for(int i = 0; i < n; ++i)
            syms[s][i] = sym[i];
        for(int i = 0; i < edges.size(); ++i)
            esyms[s][i] = a[sym[edges[i].first]][sym[edges[i].second]];
        ++s;
        return;
    }
    for(int i = 0; i < n; ++i){
        if(used[i])
            continue;
        bool fail = false;
        for(int j = 0; j < level; ++j)
            if((a[j][level] == -1) != (a[sym[j]][i] == -1)){
                fail = true;
                break;
            }
        if(fail)
            continue;
        sym[level] = i;
        used[i] = true;
        find_syms(level+1);
        used[i] = false;
    }
}

int cnt;
int pathes[C][N];
int path[N];
int another_path[N];
void solve(int len=0){
    if(len == n-1){
        for(int i = 0; i < s; ++i){
            for(int j = 0; j < n-1; ++j)
                another_path[j] = esyms[i][path[j]];
            sort(another_path, another_path+n);
            for(int j = 0; j < cnt; ++j){
                bool ok = false;
                for(int k = 0; k < n-1; ++k)
                    if(another_path[k] != pathes[j][k]){
                        ok = true;
                        break;
                    }
                if(!ok)
                    return;
            }
        }
        for(int i = 0; i < n-1; ++i)
            pathes[cnt][i] = path[i];
        for(int i = 0; i < n-1; ++i)
            print(path[i]+1);
        cout << endl;
        ++cnt;
        return;
    }
    for(int i = 0; i < edges.size() && cnt < 15; ++i){
        int v = edges[i].first, u = edges[i].second;
        if(used[v] && !used[u]){
            used[u] = true;
            path[len] = i;
            solve(len+1);
            used[u] = false;
        }
        else if(!used[v] && used[u]){
            used[v] = true;
            path[len] = i;
            solve(len+1);
            used[v] = false;
        }
    }
}

int main(){
    freopen("polyedr.in", "r", stdin);
    freopen("polyedr.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    for(int i = 0; i < N; ++i)
        for(int j = 0; j < N; ++j)
            a[i][j] = -1;
    while(getline(cin, str)){
        int num = 0;
        vector<int> nums;
        for(int i = 0; i <= str.size(); ++i){
            if(i == str.size() || str[i] == ' '){
                if(num == 0)
                    continue;
                if(n < num-1)
                    nums.push_back(num-1);
                num = 0;
            }
            else num = num*10 + (str[i]-'0');
        }
        sort(nums.begin(), nums.end());
        for(int i = 0; i < nums.size(); ++i){
            a[n][nums[i]] = edges.size();
            a[nums[i]][n] = edges.size();
            edges.push_back(pair<int, int>(n, nums[i]));
        }
        ++n;
    }
    find_syms();
    used[0] = true;
    solve();
}
