/* GCC */
#include <bits/stdc++.h>

using namespace std;

int n = 21, m = 1;
vector<vector<int> > edges(n, vector<int>(n, 0)), sym;
vector<vector<bool> > ans;
vector<bool> afterSym, used, curr;
vector<int> currSym(1);
vector<pair<int, int> > pairs(1);
int length = 0, notAdded = 0;

void readData(){
    int i = 0;
    string s;
    while (getline(cin, s)){
        i++;
        stringstream ss(s);
        int z;
        vector<int> dots;
        while (ss>>z){
            dots.push_back(z);
        }
        sort(dots.begin(), dots.end());
        for (z = 0; z < (int)dots.size(); z++){
            if (i > dots[z]) continue;
            edges[i][dots[z]] = edges[dots[z]][i] = m++;
            pairs.push_back(make_pair(i, dots[z]));
        }
    }
    n = i+1;
    curr.assign(m, false);
}

vector<bool> getSym(int a){
    vector<bool> b(m, false);
    for (int i = 1; i < m; i++){
        if (curr[i]){
            int dot1 = pairs[i].first;
            int dot2 = pairs[i].second;
            dot1 = sym[a][dot1];
            dot2 = sym[a][dot2];
            b[edges[dot1][dot2]] = true;
        }
    }
    return b;
}

void add(){
    for (unsigned int i = 0; i < sym.size(); i++){
        afterSym = getSym(i);
        for (unsigned int z = 0; z < ans.size(); z++){
            if (afterSym == ans[z]) return;
        }
    }
    ans.push_back(curr);
    notAdded = -1;
}

void findScans(){
    if (length == n-2){
        add();
        notAdded++;
        return;
    }
    for (int edge = 1; edge < m; edge++){
        int i = pairs[edge].first;
        int z = pairs[edge].second;
        if (!used[i]) swap(i, z);
        if (used[i] == used[z]) continue;
        used[z] = true;
        curr[edge] = true;
        length++;
        findScans();
        if (ans.size() == 15) return;
        length--;
        curr[edge] = false;
        used[z] = false;
    }
}

void findSyms(){
    int last = currSym.size()-1;
    for (int i = 1; i < last; i++){
        if ((bool)edges[last][i] != (bool)edges[currSym[i]][currSym[last]]){
            return;
        }
    }
    if ((int)currSym.size() == n){
        sym.push_back(currSym);
        return;
    }
    for (int i = 1; i < n; i++){
        if (used[i]) continue;
        used[i] = true;
        currSym.push_back(i);
        findSyms();
        currSym.pop_back();
        used[i] = false;
    }
}

void fileOut(){
    for (unsigned int i = 0; i < ans.size(); i++){
        for (unsigned int z = 0; z < ans[i].size(); z++){
            if (ans[i][z]) printf("%3d", z);
        }
        printf("\n");
    }
}

int main(){
    freopen("polyedr.in", "r", stdin);
    freopen("polyedr.out", "w", stdout);
    readData();
    used.assign(n, false);
    findSyms();
    used.assign(n, false);
    used[1] = true;
    findScans();
    fileOut();
}























